<!doctype html>
<html>
<head>
  <meta charset="utf-8">
  <style>
  body {font-family: Calibri, Georgia; font-size: 11pt; }
  h1, h2, h3 {font-family: Cambria, Arial, Helvetica; font-weight: lighter; color: #12945b;}
  h1 {font-size: 26pt; }
  h2 {font-size: 14pt; }
  h3 {font-size: 12pt; }
  code {font-family: Courier New; font-weight: bold; color: blue }
  table {border-radius: 5px; border: 2px solid black; }
  td, th {border: 1px solid gray; }
  ul.innerlist {list-style: none; margin: 0; padding: 0}
  td, pre {color: blue}
  </style>
</head>
<body>
<div id="content">
<h1>CSC 333/Cryptology<br />Week 5 assignment</h1>
<hr />
<h2>AES encryption (60 points)</h2>
<p>
Please write a program to perform the first round of AES encryption using a 128-bit key.  The inputs are a 128-bit plaintext and a 128-bit key.  Your code is to perform the following steps, as taken from the pseudo-code found on page 15 of the FIPS-197 document:
<pre>
AddRoundKey(state, key) // See Section 5.1.4
SubBytes(state)         // See Section 5.1.1
ShiftRows(state)        // See Section 5.1.2
MixColumns(state)       // See Section 5.1.3
</pre>
In this code <code>state</code> is the 16-byte plaintext (as it is modified) and <code>key</code> is the 16-byte key.
</p>
<p>
Test your program on the inputs found in Appendix B of the FIPS-197 document (page 33).  Looking at that, here is what should be in the <code>state</code> array after each step:
<pre>
AddRoundKey(state, key): 19 a0 9a e9 3d f4 c6 f8 e3 e2 8d 48 be 2b 2a 08
SubBytes(state):         d4 e0 b8 1e 27 bf b4 41 11 98 5d 52 ae f1 e5 30
ShiftRows(state):        d4 e0 b8 1e bf b4 41 27 5d 52 11 98 30 ae f1 e5
MixColumns(state):       04 e0 48 28 66 cb f8 06 81 19 d3 26 e5 9a 7a 4c
</pre>
</p>
<p>
You may work in teams of up to three people, although you may also work alone.  At the top of every file submitted, list all of the people who are part of the team.
</p>
<h2>Input</h2>
<p>
The input should be two strings, each containing 32 hexadecimal characters.  The first one should be the key and the second the plaintext.  Test your program on the input pair:
<pre>
2b7e151628aed2a6abf7158809cf4f3c
3243f6a8885a308d313198a2e0370734
</pre>
</p>
<h2>Submission guidelines</h2>
<p>
<ul>
<li>Your solution must be the source code for a program.  Call the program <code>AESv1.ext</code>, where <code>ext</code> is the appropriate extension for the programming language.</li>
<li>At the top of every submitted file there must be a comment line listing everyone involved with writing the code.</li>
<li>Submit the document through the D2L dropbox provided for it.</li>
</ul>
</p>
<ul>
</div>
<div>
<p><em>Last updated on Saturday, April 30th, 2016.</em></p>
</div>
</body>
</html>
